unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, Buttons, StdCtrls, CustSaveIt, ComCtrls,
  AlmostSave, MultiSaveIt, GenericSave;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    SaveAs1: TMenuItem;
    Save1: TMenuItem;
    Open1: TMenuItem;
    New1: TMenuItem;
    Panel1: TPanel;
    NewButton: TSpeedButton;
    OpenButton: TSpeedButton;
    SaveButton: TSpeedButton;
    SaveAsButton: TSpeedButton;
    TextMemo: TMemo;
    MultiSaveIt1: TMultiSaveIt;
    TextSaveItType: TMultiSaveItType;
    N3: TMenuItem;
    Close1: TMenuItem;
    N2: TMenuItem;
    CloseButton: TSpeedButton;
    RichPanel: TPanel;
    SpeedBar: TPanel;
    Bevel1: TBevel;
    BoldButton: TSpeedButton;
    ItalicButton: TSpeedButton;
    UnderlineButton: TSpeedButton;
    BulletsButton: TSpeedButton;
    FontName: TComboBox;
    FontSize: TEdit;
    UpDown1: TUpDown;
    RichEdit1: TRichEdit;
    RichMultiSaveItType: TMultiSaveItType;
    GroupBox1: TGroupBox;
    Panel2: TPanel;
    PageControl1: TPageControl;
    TabSheet4: TTabSheet;
    Memo4: TMemo;
    TabSheet2: TTabSheet;
    Memo2: TMemo;
    TabSheet5: TTabSheet;
    Memo5: TMemo;
    procedure Exit1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure TextSaveItTypeDataSave(Sender: TObject; FileName: String;
      var Success: Boolean);
    procedure TextSaveItTypeDataLoad(Sender: TObject; FileName: String;
      var Success: Boolean);
    procedure TextMemoChange(Sender: TObject);
    procedure TextSaveItTypeFileNew(Sender: TObject; var Success: Boolean);
    procedure TextSaveItTypeDataCheck(Sender: TObject; var Has_Data: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure MultiSaveIt1AllowSave(Sender: TObject; Allowed: Boolean);
    procedure MultiSaveIt1AllowSaveAs(Sender: TObject; Allowed: Boolean);
    procedure MultiSaveIt1AllowClose(Sender: TObject; Allowed: Boolean);
    procedure NewButtonClick(Sender: TObject);
    procedure FontNameChange(Sender: TObject);
    procedure FontSizeChange(Sender: TObject);
    procedure BoldButtonClick(Sender: TObject);
    procedure ItalicButtonClick(Sender: TObject);
    procedure UnderlineButtonClick(Sender: TObject);
    procedure BulletsButtonClick(Sender: TObject);
    procedure RichEdit1SelectionChange(Sender: TObject);
    procedure RichMultiSaveItTypeDataCheck(Sender: TObject;
      var Has_Data: Boolean);
    procedure RichMultiSaveItTypeDataLoad(Sender: TObject; FileName: String;
      var Success: Boolean);
    procedure RichMultiSaveItTypeDataSave(Sender: TObject; FileName: String;
      var Success: Boolean);
    procedure RichMultiSaveItTypeFileNew(Sender: TObject;
      var Success: Boolean);
    procedure RichEdit1Change(Sender: TObject);
    procedure TextSaveItTypeFileClosed(Sender: TObject);
    procedure RichMultiSaveItTypeFileClosed(Sender: TObject);
  private
    // *** Begin Ignorable Code ***
    FUpdating: Boolean;

    procedure ShowMemo;
    procedure ShowRichPanel;

    function CurrText: TTextAttributes;
    procedure GetFontNames;

    // *** End Ignorable Code ***
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

// *** Begin Ignorable Code ***

procedure TForm1.ShowMemo;
begin
  with TextMemo do
  begin
    Show;
    BringToFront;
    SetFocus;
  end;
end;

procedure TForm1.ShowRichPanel;
begin
  with RichPanel do
  begin
    Show;
    BringToFront;
  end;
  RichEdit1.SetFocus;  
end;

function TForm1.CurrText: TTextAttributes;
begin
  if RichEdit1.SelLength > 0 then
    Result := RichEdit1.SelAttributes
  else
    Result := RichEdit1.DefAttributes;
end;

function EnumFontsProc(var LogFont: TLogFont; var TextMetric: TTextMetric;
  FontType: Integer; Data: Pointer): Integer; stdcall;
begin
  TStrings(Data).Add(LogFont.lfFaceName);
  Result := 1;
end;

procedure TForm1.GetFontNames;
var
  DC: HDC;
begin
  DC := GetDC(0);
  EnumFonts(DC, nil, @EnumFontsProc, Pointer(FontName.Items));
  ReleaseDC(0, DC);
  FontName.Sorted := True;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Application.Title := Caption; // Set Application Title to Form's Caption
  GetFontNames;
end;

procedure TForm1.FontNameChange(Sender: TObject);
begin
  if FUpdating then Exit;
  CurrText.Name := FontName.Items[FontName.ItemIndex];
end;

procedure TForm1.FontSizeChange(Sender: TObject);
begin
  if FUpdating then Exit;
  CurrText.Size := StrToInt(FontSize.Text);
end;

procedure TForm1.BoldButtonClick(Sender: TObject);
begin
  if FUpdating then Exit;
  if BoldButton.Down then
    CurrText.Style := CurrText.Style + [fsBold]
  else
    CurrText.Style := CurrText.Style - [fsBold];
end;

procedure TForm1.ItalicButtonClick(Sender: TObject);
begin
  if FUpdating then Exit;
  if ItalicButton.Down then
    CurrText.Style := CurrText.Style + [fsItalic]
  else
    CurrText.Style := CurrText.Style - [fsItalic];
end;

procedure TForm1.UnderlineButtonClick(Sender: TObject);
begin
  if FUpdating then Exit;
  if UnderlineButton.Down then
    CurrText.Style := CurrText.Style + [fsUnderline]
  else
    CurrText.Style := CurrText.Style - [fsUnderline];
end;

procedure TForm1.BulletsButtonClick(Sender: TObject);
begin
  if FUpdating then Exit;
  RichEdit1.Paragraph.Numbering := TNumberingStyle(BulletsButton.Down);
end;

procedure TForm1.RichEdit1SelectionChange(Sender: TObject);
begin
  with RichEdit1.Paragraph do
  try
    FUpdating := True;
    BoldButton.Down := fsBold in RichEdit1.SelAttributes.Style;
    ItalicButton.Down := fsItalic in RichEdit1.SelAttributes.Style;
    UnderlineButton.Down := fsUnderline in RichEdit1.SelAttributes.Style;
    BulletsButton.Down := Boolean(Numbering);
    FontSize.Text := IntToStr(RichEdit1.SelAttributes.Size);
    FontName.Text := RichEdit1.SelAttributes.Name;
  finally
    FUpdating := False;
  end;
end;

// *** End Ignorable Code ***

// *** Begin Important Code ***

procedure TForm1.Open1Click(Sender: TObject);
begin
  MultiSaveIt1.Open;
end;

procedure TForm1.SaveAs1Click(Sender: TObject);
begin
  MultiSaveIt1.SaveAs;
end;

procedure TForm1.Save1Click(Sender: TObject);
begin
  MultiSaveIt1.Save;
end;

procedure TForm1.New1Click(Sender: TObject);
begin
  MultiSaveIt1.New;
end;

procedure TForm1.TextSaveItTypeDataSave(Sender: TObject; FileName: String;
  var Success: Boolean);
begin
  TextMemo.Lines.SaveToFile(FileName);
end;

procedure TForm1.TextSaveItTypeDataLoad(Sender: TObject; FileName: String;
  var Success: Boolean);
begin
  ShowMemo;
  TextMemo.Lines.LoadFromFile(FileName);
    ShowMessage('wait');  
end;

procedure TForm1.TextMemoChange(Sender: TObject);
begin
  TextSaveItType.Modified;
end;

procedure TForm1.TextSaveItTypeFileNew(Sender: TObject; var Success: Boolean);
begin
  // Create New Memo
  TextMemo.Lines.Clear;
  ShowMemo;
end;

procedure TForm1.TextSaveItTypeDataCheck(Sender: TObject; var Has_Data: Boolean);
begin
  Has_Data := Length(Trim(TextMemo.Text)) > 0;
end;

procedure TForm1.Close1Click(Sender: TObject);
begin
  MultiSaveIt1.Close;
end;

procedure TForm1.MultiSaveIt1AllowSave(Sender: TObject; Allowed: Boolean);
begin
  Save1.Enabled := Allowed;
  SaveButton.Enabled := Allowed;
end;

procedure TForm1.MultiSaveIt1AllowSaveAs(Sender: TObject;
  Allowed: Boolean);
begin
  SaveAs1.Enabled := Allowed;
  SaveAsButton.Enabled := Allowed;
end;

procedure TForm1.MultiSaveIt1AllowClose(Sender: TObject; Allowed: Boolean);
begin
  Close1.Enabled      := Allowed;
  CloseButton.Enabled := Allowed;
end;

procedure TForm1.NewButtonClick(Sender: TObject);
begin
  MultiSaveIt1.NewDefault;
end;

procedure TForm1.RichMultiSaveItTypeDataCheck(Sender: TObject;
  var Has_Data: Boolean);
begin
  Has_Data := Length(Trim(RichEdit1.Text)) > 0;
end;

procedure TForm1.RichMultiSaveItTypeDataLoad(Sender: TObject;
  FileName: String; var Success: Boolean);
begin
  // Load From File
  ShowRichPanel;
  RichEdit1.Lines.LoadFromFile(FileName);
  RichEdit1SelectionChange(Sender); // Update Fonts & Stuff
end;

procedure TForm1.RichMultiSaveItTypeDataSave(Sender: TObject;
  FileName: String; var Success: Boolean);
begin
  // Save To File
  RichEdit1.Lines.SaveToFile(FileName);
end;

procedure TForm1.RichMultiSaveItTypeFileNew(Sender: TObject;
  var Success: Boolean);
begin
  // Create New RichText Doc
  RichEdit1.Lines.Clear;
  RichEdit1SelectionChange(Sender); // Update Fonts & Stuff
  ShowRichPanel;
end;

procedure TForm1.RichEdit1Change(Sender: TObject);
begin
  // Notifiy TMultiSaveIt that the document needs saving
  RichMultiSaveItType.Modified;
end;

procedure TForm1.TextSaveItTypeFileClosed(Sender: TObject);
begin
  TextMemo.Hide;
end;

procedure TForm1.RichMultiSaveItTypeFileClosed(Sender: TObject);
begin
  RichPanel.Hide;
end;

// *** End Important Code ***

end.
